import processing.core.*; 
import processing.xml.*; 

import toxi.geom.*; 
import toxi.geom.mesh.*; 
import toxi.geom.mesh.subdiv.*; 
import toxi.processing.*; 
import toxi.util.*; 
import toxi.volume.*; 
import processing.opengl.*; 
import javax.media.opengl.*; 
import controlP5.*; 
import javax.swing.*; 
import SpringGUI.*; 
import unlekker.data.*; 
import unlekker.geom.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class A07_Voxelize_AABB_ extends PApplet {



// Digital Material Cube 007
// FabLab Japan
// Hiroya Tanaka


// Import Mesh Library 






ToxiclibsSupport gfx;
WETriangleMesh mesh;

boolean mesh_display = true;
boolean voxel_display = true;
boolean wire_display = true;

// Import

  



SpringGUI gui; 

// File IO
String getFile; 
String setFile;
String [] txtarray = null;
String txt = null;

// Field 
int FIELD_SIZE =  50;
int FIELD_STEP =  10;

// Camera 
float expo = 1;
float rotx, roty;
float rate = 0.01f;

// Resolution of Box
int resolution = 1;

// ControlP5
ControlP5 controlP5;
Textfield tfUserName;       // \u30c6\u30ad\u30b9\u30c8\u30d5\u30a3\u30fc\u30eb\u30c9
String txts = "";

// Text
PFont  font;  
long   time;  

// Unlekker


STL stl;
FaceList poly;
int faces; // \u30e1\u30c3\u30b7\u30e5\u306e\u6570

// Array 
int[][] xyarrays = new int[48][48];
int[][] yzarrays = new int[48][48];
int[][] zxarrays = new int[48][48];
int[][][] xyzarrays = new int[48][48][48];


public void setup() {
  
  // Array\u521d\u671f\u5316
    for(int k = 0; k<48; k = k + 1){
    for(int j = 0; j<48; j = j + 1){
    for(int i = 0; i<48; i = i + 1){
            xyzarrays[k][j][i] = 0; 
    }
    }
    }
    
    
  size(640, 480, OPENGL);    
  gfx=new ToxiclibsSupport(this);
  controlP5 = new ControlP5(this);  
  controlP5.addButton("loadfile",1,10,45,80,19);
  controlP5.addButton("savefile",1,100,45,80,19);
  controlP5.addButton("voxelize",1,190,45,80,19);
  controlP5.addSlider("resolution",1,48,10,70,200,20);
  
  controlP5.addToggle("mesh_display",true,300,45,20,10).setMode(ControlP5.SWITCH);
  controlP5.addToggle("voxel_display",true,400,45,20,10).setMode(ControlP5.SWITCH);
  controlP5.addToggle("wire_display",true,500,45,20,10).setMode(ControlP5.SWITCH);
}


public void draw() {
  
  System.gc();
  
  background(0);
 // PGraphicsOpenGL pgl = (PGraphicsOpenGL)g;  

  
  // Lighting
    ambientLight(150, 150, 150);
    directionalLight(255,255,255,-1,0,0);
    pointLight(160, 160, 160, mouseX, mouseY, 200);
    spotLight(100, 100, 100, mouseX, mouseY, 200, 0, 0, -1, PI, 2);
    
  // Camera
  if (getFile == null && setFile == null) {
    if (mousePressed){
  rotx = rotx + (mouseY - pmouseY) * rate;
  roty = roty + (mouseX - pmouseX) * rate; 
    }
  } else { 
  rotx = 0;
  roty = 0;
  expo = 1;
  }
  
    
  // FileIO
    if(getFile != null){
    //\u30d5\u30a1\u30a4\u30eb\u3092\u53d6\u308a\u8fbc\u3080
    fileLoader(); 
  } 
  
  //Text
  font = createFont("Meiryo", 12);
  textFont(font);
  fill(255,255,255);
  text("07  VOXELIZE in AABB", 10, 25); 
  
 // Zoom In and Out
if (keyPressed && keyCode==UP) { expo = expo + 0.01f; }
if (keyPressed && keyCode==DOWN) { expo = expo - 0.01f; }

// \u4e2d\u5fc3\u3092\u5408\u308f\u305b\u308b
  pushMatrix(); 
  translate(320,240,200);
  rotateX(rotx); rotateY(roty); scale(expo);  
    
    

 
  // \u30d5\u30ec\u30fc\u30e0\u306e\u63cf\u753b
  

  stroke(255, 255, 255);  
  FIELD_STEP = FIELD_SIZE*2/resolution;
  
  for(int k = 1; k<=resolution; k = k + 1){
    for(int j = 1; j<=resolution; j = j + 1){
       for(int i = 1; i<=resolution; i = i + 1){
       
          // x
          float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
          float xx = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          // y
          float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
          float yy = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          // z
          float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
          float zz = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 
        
        pushMatrix(); 
        translate(realx,realy,realz);
        noFill();
        if (wire_display == true){
        box(FIELD_STEP ,FIELD_STEP ,FIELD_STEP );
        }
        popMatrix();
       }
    }
  }

  

    // STL\u66f8\u304d\u51fa\u3057
    if(setFile != null){
   beginRaw("unlekker.data.STL",setFile+".stl");
   println("start :"+setFile);
  }
  
  // \u30e1\u30c3\u30b7\u30e5\u306e\u63cf\u753b

  
  if(poly!=null && mesh_display == true) {
    fill(255,255,255);
    noStroke();
    poly.draw(this);
  }
  

  
    // \u30dc\u30af\u30bb\u30eb\u306e\u63cf\u753b  

  noStroke();
  noFill();
  int len = txts.length(); 
  int l = 0;
  
  FIELD_STEP = FIELD_SIZE*2/resolution;

  for(int k = 1; k<=resolution; k = k + 1){
    for(int j = 1; j<=resolution; j = j + 1){
       for(int i = 1; i<=resolution; i = i + 1){
       
          //x
          float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
          float xx = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          //y
          float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
          float yy = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          //z
          float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
          float zz = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 
        
         pushMatrix();
         translate(realx,realy,realz); 
         if(  xyzarrays[i-1][j-1][k-1] == 1 && voxel_display == true )  { fill(200,00,00); box(FIELD_STEP,FIELD_STEP,FIELD_STEP); }

            
         popMatrix();
       }
    }
  }
  popMatrix();
  
   // STL\u66f8\u304d\u51fa\u3057\u7d42\u4e86
  if(setFile !=null) {
  endRaw();   
 setFile = null;
   println("end");
  }
 
 controlP5.draw();
 
}


// \u30c6\u30ad\u30b9\u30c8\u304c\u5165\u529b\u3055\u308c\u305f\u969b\u306b\u30b3\u30fc\u30eb\u30d0\u30c3\u30af\u3055\u308c\u308b\u30e1\u30bd\u30c3\u30c9
public synchronized void textfield(String txt) {
    txts = txt; 
}


public void loadfile(int theValue) {
    getFile = getFileName();
}


public void savefile(int theValue) {
     setFile = setFileName();
}

public void voxelize(int theValue) {
  
  // \u30e1\u30c3\u30b7\u30e5\u306e\u6570\uff1aint faces\u3000\u3000
  // AABB * AABB\u306e\u885d\u7a81\u5224\u5b9a\u3092\u3064\u304b\u3063\u3066\u307f\u308b
  

  FIELD_STEP = FIELD_SIZE*2/resolution;
  
  for(int k = 1; k<=resolution; k = k + 1){
    for(int j = 1; j<=resolution; j = j + 1){
       for(int i = 1; i<=resolution; i = i + 1){
       
          // x
          float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
          float xx = -FIELD_SIZE + FIELD_STEP*(i);
        
          // y
          float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
          float yy = -FIELD_SIZE + FIELD_STEP*(j);
       
          //z
          float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
          float zz = -FIELD_SIZE + FIELD_STEP*(k);

        
          

          for(int q = 0; q< poly.f.length; q= q + 1){
            
            boolean result = AABB( x, y, z, xx, yy, zz,  
            min(poly.f[q].v[3],poly.f[q].v[6],poly.f[q].v[9]), min(poly.f[q].v[4],poly.f[q].v[7],poly.f[q].v[10]), min(poly.f[q].v[5],poly.f[q].v[8],poly.f[q].v[11]),
            max(poly.f[q].v[3],poly.f[q].v[6],poly.f[q].v[9]), max(poly.f[q].v[4],poly.f[q].v[7],poly.f[q].v[10]), max(poly.f[q].v[5],poly.f[q].v[8],poly.f[q].v[11])); 
            //println(i + " ... "+ j + " ... " + k + " ... " + q + " = " + result);
         if (result == true) {      
             xyzarrays[i-1][j-1][k-1] = 1;  break;
         } else { 
             xyzarrays[i-1][j-1][k-1] = 0;  
         }
                
          }
       }
    }
  }
}

// AABB\u3069\u3046\u3061\u306e\u63a5\u89e6\u3092\u8abf\u3079\u308b

public boolean AABB(float aminx,float aminy,float aminz, float amaxx,float amaxy, float amaxz, float bminx, float bminy, float bminz, float bmaxx, float bmaxy, float bmaxz) {
  // \u885d\u7a81	
  if(              aminx < bmaxx && amaxx > bminx
		&& aminy < bmaxy && amaxy > bminy
		&& aminz < bmaxz && amaxz > bminz)
	{
                //println("1a");
		return(true);
	}
  if(              bminx < amaxx && bmaxx > aminx
		&& bminy < amaxy && bmaxy > aminy
		&& bminz < amaxz && bmaxz > aminz)
	{
               // println("1b");
		return(true);
	}

  // \u5305\u542b
  if(              aminx < bminx && bmaxx < amaxx
		&& aminy < bminy && bmaxy < amaxy
		&& aminz < bminz && bmaxz < amaxz)
	{
		//println("2");
                return(true);
	}
  if(              bminx < aminx && amaxx < bmaxx
		&& bminy < aminy && amaxy < bmaxy
		&& bminz < aminz && amaxz < bmaxz)
	{
		//println("3");
                return(true);
	}
	return(false);
}

// \u5ea7\u6a19 p1,p2 \u3092\u901a\u308b\u76f4\u7dda\u3068\u5ea7\u6a19 p3,p4 \u3092\u7d50\u3076\u7dda\u5206\u304c\u4ea4\u5dee\u3057\u3066\u3044\u308b\u304b\u3092\u8abf\u3079\u308b
public boolean intersection(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4){
       
    if (((x1 - x2) * (y3 - y1) + (y1 - y2) * (x1 - x3)) * ((x1 - x2) * (y4 - y1) + (y1 - y2) * (x1 - x4)) <= 0 &&
        ((x3 - x4) * (y1 - y3) + (y3 - y4) * (x3 - x1)) * ((x3 - x4) * (y2 - y3) + (y3 - y4) * (x3 - x2)) <= 0 ) {
    
            return(true); //\u4ea4\u5dee\u3059\u308b
            
            
    } 
    
    return(false); //\u4ea4\u5dee\u3057\u306a\u3044
  
    }
    
//\u30d5\u30a1\u30a4\u30eb\u3092\u53d6\u308a\u8fbc\u3080\u30d5\u30a1\u30f3\u30af\u30b7\u30e7\u30f3 
public void fileLoader(){
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u306e\u30c9\u30c3\u30c8\u4ee5\u964d\u306e\u6587\u5b57\u5217\u3092\u53d6\u5f97
  String ext = getFile.substring(getFile.lastIndexOf('.') + 1);
  //\u305d\u306e\u6587\u5b57\u5217\u3092\u5c0f\u6587\u5b57\u306b\u3059\u308b
  ext.toLowerCase();
  //\u6587\u5b57\u5217\u672b\u5c3e\u304cstl\u3067\u3042\u308c\u3070 
  if(ext.equals("stl")){
    println(ext);
  stl=new STL(this,getFile);
  // Get polygon data

  poly=stl.getPolyData();
  faces = poly.num;
  poly.normalize(FIELD_SIZE*2); // normalize object to 400 radius
  poly.calcBounds();
  poly.center(); // center it around world origin
  

  
}
  
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u3092\u7a7a\u306b\u623b\u3059
  getFile = null; 
}



//\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u3001\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97\u306e\u51e6\u7406 
public String getFileName(){
  //\u51e6\u7406\u30bf\u30a4\u30df\u30f3\u30b0\u306e\u8a2d\u5b9a 
  SwingUtilities.invokeLater(new Runnable() { 
    public void run() {
 try {
   //\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u8868\u793a 
   JFileChooser fc = new JFileChooser(); 
   int returnVal = fc.showOpenDialog(null);
   //\u300c\u958b\u304f\u300d\u30dc\u30bf\u30f3\u304c\u62bc\u3055\u308c\u305f\u5834\u5408
   if (returnVal == JFileChooser.APPROVE_OPTION) {
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u53d6\u5f97 
     File file = fc.getSelectedFile();
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u306e\u30d1\u30b9\u53d6\u5f97 
     getFile = file.getPath(); 
   } 
 }
 //\u4e0a\u8a18\u4ee5\u5916\u306e\u5834\u5408 
 catch (Exception e) {
   //\u30a8\u30e9\u30fc\u51fa\u529b 
   e.printStackTrace(); 
 } 
    } 
  } 
  );
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97
  return getFile; 
}


//\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u3001\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97\u306e\u51e6\u7406 
public String setFileName(){
  //\u51e6\u7406\u30bf\u30a4\u30df\u30f3\u30b0\u306e\u8a2d\u5b9a 
  SwingUtilities.invokeLater(new Runnable() { 
    public void run() {
 try {
   //\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u8868\u793a 
   JFileChooser fc = new JFileChooser(); 
   int returnVal = fc.showSaveDialog(null);
   //\u300c\u958b\u304f\u300d\u30dc\u30bf\u30f3\u304c\u62bc\u3055\u308c\u305f\u5834\u5408
   if (returnVal == JFileChooser.APPROVE_OPTION) {
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u53d6\u5f97 
     File file = fc.getSelectedFile();
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u306e\u30d1\u30b9\u53d6\u5f97 
     setFile = file.getPath(); 
   } 
 }
 //\u4e0a\u8a18\u4ee5\u5916\u306e\u5834\u5408 
 catch (Exception e) {
   //\u30a8\u30e9\u30fc\u51fa\u529b 
   e.printStackTrace(); 
 } 
    } 
  } 
  );
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97
  return setFile; 
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "A07_Voxelize_AABB_" });
  }
}
